// --------------------------------------------------------------------------
// Sym-1 Cylon display example
//
// Wayne Parham
//
// wayne@parhamdata.com
// --------------------------------------------------------------------------

#include <stdio.h>
#include <sym1.h>

void main (void) {
   int  c          =   0;
   int  d          =   0;
   int  flashes    = 255;
   int  edge_delay =  48;
   int  direction  =   0;              // 0 = right, 1 = left

   puts( "\n\nLook at the front panel.\n" );

   DISPLAY.d0 = DISP_BOTTOM;
   DISPLAY.d1 = DISP_SPACE;
   DISPLAY.d2 = DISP_SPACE;
   DISPLAY.d3 = DISP_SPACE;
   DISPLAY.d4 = DISP_SPACE;
   DISPLAY.d5 = DISP_SPACE;
   DISPLAY.d6 = DISP_SPACE;

   while( 1 ) {

      if( direction ) {                // Scroll Left
         DISPLAY.d0 = DISPLAY.d1;
         DISPLAY.d1 = DISPLAY.d2;
         DISPLAY.d2 = DISPLAY.d3;
         DISPLAY.d3 = DISPLAY.d4;
         DISPLAY.d4 = DISPLAY.d5;
         DISPLAY.d5 = DISP_SPACE;
      }
      else {                           // Scroll Right
         DISPLAY.d5 = DISPLAY.d4;
         DISPLAY.d4 = DISPLAY.d3;
         DISPLAY.d3 = DISPLAY.d2;
         DISPLAY.d2 = DISPLAY.d1;
         DISPLAY.d1 = DISPLAY.d0;
         DISPLAY.d0 = DISP_SPACE;
      }

      for( d = 0; d < flashes ; d++ ) {
         fdisp();                      // Display
      }

      if( get_D0() == DISP_BOTTOM ) {
         direction = 0;
         for( d = 0; d < edge_delay ; d++ ) {
            fdisp();                   // Wait a litle longer
         }
      }
      else if( get_D5() == DISP_BOTTOM ) {
         direction = 1;
         for( d = 0; d < edge_delay ; d++ ) {
            fdisp();                   // at the edges
         }
      }
   }

   return;
}
